/****************************************************************************
                  INTERNATIONAL AVS CENTER
	(This disclaimer must remain at the top of all files)

WARRANTY DISCLAIMER

This module and the files associated with it are distributed free of charge.
It is placed in the public domain and permission is granted for anyone to use,
duplicate, modify, and redistribute it unless otherwise noted.  Some modules
may be copyrighted.  You agree to abide by the conditions also included in
the AVS Licensing Agreement, version 1.0, located in the main module
directory located at the International AVS Center ftp site and to include
the AVS Licensing Agreement when you distribute any files downloaded from 
that site.

The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module provide absolutely
NO WARRANTY OF ANY KIND with respect to this software.  The entire risk as to
the quality and performance of this software is with the user.  IN NO EVENT
WILL The International AVS Center, MCNC, the AVS Consortium and the individual
submitting the module and files associated with said module BE LIABLE TO
ANYONE FOR ANY DAMAGES ARISING FROM THE USE OF THIS SOFTWARE, INCLUDING,
WITHOUT LIMITATION, DAMAGES RESULTING FROM LOST DATA OR LOST PROFITS, OR ANY
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES.

This AVS module and associated files are public domain software unless
otherwise noted.  Permission is hereby granted to do whatever you like with
it, subject to the conditions that may exist in copyrighted materials. Should
you wish to make a contribution toward the improvement, modification, or
general performance of this module, please send us your comments:  why you
liked or disliked it, how you use it, and most important, how it helps your
work. We will receive your comments at avs@ncsc.org.

Please send AVS module bug reports to avs@ncsc.org.

******************************************************************************/
/* NOTE:  THIS MODULE AND SOURCE CODE IS FOR USE 
   WITH THE AVS SOFTWARE ENVIRONMENT ONLY */
/* mod_gen Version 1                                                     */
/* Module Name: "deleteGeom" (Output) (Subroutine)                       */
/* Author: John Stephen (Tessella) 0235-555511                           */
/* Date Created: Wed Jan  6 14:38:28 1993                                */
/*                                                                       */
/* This file is automatically generated by the Module Generator (mod_gen)*/
/* Please do not modify or move the contents of this comment block as    */
/* mod_gen needs it in order to read module sources back in.             */
/*                                                                       */
/*		*** delete all geometry associated   ***		 */
/*		*** with the named module.  The      ***		 */
/*		*** module name must be AVS's system ***		 */
/*		*** name, not the alias.             ***		 */
/*                                                                       */
/* param 0 "module name" typein "" "" ":"                                */
/* End of Module Description Comments                                    */

#include <stdio.h>
#include <avs/avs.h>
#include <avs/port.h>
 
/* ----> START OF USER-SUPPLIED CODE SECTION #1 (INCLUDE FILES, GLOBAL VARIABLES)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #1                            */
 
/* *****************************************/
/*  Module Description                     */
/* *****************************************/
int deleteGeom_desc()
{

	int in_port, out_port, param;
	extern int deleteGeom_compute();

	AVSset_module_name("deleteGeom", MODULE_RENDER);

	/* Parameter Specifications                */
	param = AVSadd_parameter("module name", "string", " ", " ", ":");
	AVSconnect_widget(param, "typein");

	AVSset_compute_proc(deleteGeom_compute);
/* ----> START OF USER-SUPPLIED CODE SECTION #2 (ADDITIONAL SPECIFICATION INFO)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #2                            */
	return(1);
}
 
/* *****************************************/
/* Module Compute Routine                  */
/* *****************************************/
int deleteGeom_compute( module_name)
	char *module_name;
{

/* ----> START OF USER-SUPPLIED CODE SECTION #3 (COMPUTE ROUTINE BODY)   */
	char com[500], *err, *out, buf[500];
	char *s[20], *c;
	int i, j;
	/* get a list of the objects associated with a module */
	sprintf(com,"geom_lookup_obj_names \"%s\"",module_name);
	AVScommand("kernel",com,&out,&err);

	/* split the list of names into a series of disrecte */
	/* one-line strings.				     */
	strncpy(buf,out,499);
	if(buf && *buf) {
		i=1; c=buf; s[0]=c;
		while(*c) {
			if(*c == '\n') {
				*c = '\0';
				c++;
				s[i]=c;
				i++;
			}
			else {
				c++;
			}
		}
		for(j=0;j<i;j++) {
			if(*s[j]) {
				/* delete each object */
				sprintf(com,"geom_delete_obj -object %s",s[j]);
puts(com);
				AVScommand("kernel",com,&out,&err);
			}
		}
	}

/* <---- END OF USER-SUPPLIED CODE SECTION #3                            */
	return(1);
}
 
/* ***********************************************************************/
/* Initialization for modules contained in this file.                    */
/* ***********************************************************************/
int ((*mod_list[])()) = {
	deleteGeom_desc,
};
#define NMODS (sizeof(mod_list) / sizeof(char *))

AVSinit_modules()
{
	AVSinit_from_module_list(mod_list, NMODS);
}
 
/* ----> START OF USER-SUPPLIED CODE SECTION #4 (SUBROUTINES, FUNCTIONS, UTILITY ROUTINES)*/
/* <---- END OF USER-SUPPLIED CODE SECTION #4                            */
